#pragma once
#include <math.h>

const double GetClosestIncrement( double in_value, double in_increment )
{
	if ( in_increment > 0.0 )
	{
		double dInteger;
		double dFraction = modf( in_value / in_increment, &dInteger );
		in_value = (dInteger + (unsigned int)(dFraction + (dFraction < 0 ? -0.5 : 0.5))) * in_increment;
	}
	return in_value;
}

template <typename T> 
const T rand_range(T a, T b)
{
	return ((b-a)*( (T)( (T)rand()/ (T) RAND_MAX ) ) )+a;
}

template <typename T>
const T lerp_value(const T a, const T b, const double t)
{
	return (a + static_cast<T>( (b-a)*t ) );
}

template <typename T>
const void lerp_value(T &dest, const T a, const T b, const double t)
{
	dest = a + (b-a)*t;
}

const void lerp_value(CVector3 &dest, const CVector3 a, const CVector3 b, const double t)
{
	dest=b;
	dest-=a;
	dest*=t;
	dest+=a;
}
const CVector3 lerp_value(const CVector3 a, const CVector3 b, const double t)
{
	CVector3 dest=b;
	dest-=a;
	dest*=t;
	dest+=a;
	return dest;
}
// evaluate a point on a bezier-curve. t goes from 0 to 1.0
template <typename T>
const void bezier(T &dest, const T& a, const T& b, const T& c, const T& d, const double t)
{
	T ab,bc,cd,abbc,bccd;
	lerp_value(ab, a,b,t);           // point between a and b (green)
	lerp_value(bc, b,c,t);           // point between b and c (green)
	lerp_value(cd, c,d,t);           // point between c and d (green)
	lerp_value(abbc, ab,bc,t);       // point between ab and bc (blue)
	lerp_value(bccd, bc,cd,t);       // point between bc and cd (blue)
	lerp_value(dest, abbc,bccd,t);   // point on the bezier-curve (black)
}